## guitarix 0.38.1

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print('Incompatible Waf, use 1.5')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.38.1'
APPNAME='guitarix'

good_faust_versions = ['2.15.11']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):

    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')

    opt.add_option('--no-standalone',
                    action='store_false',
                    dest='standalone',
                    default=True,
                    help=("Don't build standalone (JACK) application"))

    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--disable-cxx11',
                    action='store_const',
                    default=False,
                    const=True,
                    help='deselect C++ compiler flag -std=c++11 [Default: False]')

    comp.add_option('--ldflags',
                    type='string',
                    default='',
                    dest='ldflags',
                    help='C++ base linker flags ')

    comp.add_option('--enable-lfs',
                    action='store_const',
                    default=False,
                    const=True,
                    help='enable Large File Support (LFS)  ')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')

    comp.add_option('--convolver-ffmpeg',
                    action='store_const',
                    default=False,
                    const=True,
                    help='modified zita-convolver libary that uses ffmpeg instead of fftw3 for FFT (Default NO)')

    comp.add_option('--libdir',
                   type='string',
                   default='',
                   dest='libdir',
                   help=('library install path '),
                   )

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")

    faust.add_option('--faust-vectorize',
                     action='store_const',
                     default=False,
                     const=True,
                     help="call faust with --vectorize")

    faust.add_option('--faust-vectorize-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help=("call faust with --vectorize for sources built"
                           "in single (float) precision"))

    faust.add_option('--faust-options', help="additional faust options")

    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--ladspa',
                    dest='ladspa',
                    action='store_true',
                    default=False,
                    help="Build LADSPA plugins (Default no)")

    ladspa.add_option('--new-ladspa',
                    dest='new_ladspa',
                    action='store_true',
                    default=False,
                    help=("Build new LADSPA plugins (Default no)"))

    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    lv2 = opt.add_option_group("LV2 Options (installing LV2 modules)")

    lv2.add_option('--no-lv2',
                    dest='lv2',
                    action='store_false',
                    default=True,
                    help=("Don't build LV2 plugins (Default no)"))

    lv2.add_option('--no-lv2-gui',
                    dest='lv2_gui',
                    action='store_false',
                    default=True,
                    help=("Don't build LV2 plugin GUI's (Default no)"))

    lv2.add_option('--mod-lv2',
                    dest='mod_lv2',
                    action='store_true',
                    default=False,
                    help=("Install MOD LV2 GUI's (Default no)"))

    lv2.add_option('--lv2dir',
                    type='string',
                    help='LV2 plugin directory [Default: <prefix>/lib/lv2]')

    lv2.add_option('--disable-sse',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("disable SSE for lv2 plugins (ARM)"))

    style = opt.add_option_group("Style Options (installing font)")

    style.add_option('--install-roboto-font',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("install the included roboto condensed font"))

    style.add_option('--fontdir',
                    type='string',
                    help=('roboto condensed font install directory [Default: <prefix>/share/fonts/truetype]'))

    style.add_option('--no-font-cache-update',
                    action='store_const',
                    default=False,
                    const=True,
                    help='dont automatically update font cache')


    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.sub_options('src/gx_head');


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.eprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:

=== glade-gxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import Options

def set_options(opt):
    grp = opt.get_option_group("--shared-lib")
    grp.add_option('--glade-support',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build support for Glade / GtkBuilder (Developers only!!)'),
                   )
    grp.add_option('--glade-catalog-dir',
                   type='string',
                   default='/usr/share/glade3/catalogs',
                   help='Glade catalog dir [Default: %default]')
    grp.add_option('--glade-modules-dir',
                   type='string',
                   default='/usr/lib/glade3/modules',
                   help='Glade modules dir [Default: %default]')

def configure(conf):
    if Options.options.glade_support:
        conf.env["GX_GLADE_SUPPORT"] = True
        conf.env["GXW_SHARED"] = True
        conf.env["GXW_SHARED_INSTALL"] = True
        conf.env["GLADE_CATALOG_DIR"] = Options.options.glade_catalog_dir
        conf.env["GLADE_MODULES_DIR"] = Options.options.glade_modules_dir
        
def build(bld):
    if not bld.env["GX_GLADE_SUPPORT"]:
        return
    bld.add_subdirs("glade-icons")
    bld(features = ['cc','cshlib'],
        ccflags = bld.env['CXXFLAGS'],
        uselib = ['GTK2'],
        source = ['glade-gxw.c'],
        linkflags = bld.env['shlib_LINKFLAGS'].append("-lc"),
        target = 'gladegx',
        lib = ["gxw"],
        libpath = bld.path.find_dir("../libgxw/gxw").bldpath(bld.env),
        includes = ['..','../libgxw'],
        install_path = bld.env["GLADE_MODULES_DIR"],
        )

    bld.install_files(bld.env["GLADE_CATALOG_DIR"], "gxw.xml", chmod=0o644)

=== libgxwmm/gxwmm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import Task, Options, Utils, Logs, shutil, os.path
from TaskGen import extension

def set_options(opt):
    grp = opt.add_option_group("Guitarix Widget Library")
    grp.add_option('--shared-lib',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build shared library'),
                   )
    grp.add_option('--lib-dev',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('install shared library headers'),
                   )
    grp.add_option('--no-ldconfig',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('dont run ldconfig'),
                   )
    grp.add_option('--generate-cpp-wrapper',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('re-generate the pre-built c++ library wrapper files (Developers only!!)'),
                   )
    grp.add_option('--generate-resources',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('re-generate the pre-built gresources file (Developers only!!)'),
                   )

def configure(conf):
    conf.check_tool('misc')
    if Options.options.generate_cpp_wrapper:
        conf.cfg_get_variable(package='glibmm-2.4', variable='gmmprocdir')
        conf.cfg_get_variable(package='gtkmm-2.4', variable='gmmprocm4dir', prefix="GTK_")
        conf.cfg_get_variable(package='atkmm-1.6', variable='gmmprocm4dir', prefix="ATK_")
        conf.cfg_get_variable(package='pangomm-1.4', variable='gmmprocm4dir', prefix="PANGO_")
        conf.env["USE_GENERATED_CPP"] = False
    else:
        conf.env["USE_GENERATED_CPP"] = True
    if Options.options.shared_lib or Options.options.lv2:
        conf.env["GX_LIB_SHARED"] = True
    else:
        conf.env["GX_LIB_STATIC"] = True
    if Options.options.lib_dev:
        conf.env["GX_LIB_SHARED"] = True
        conf.env["GX_LIB_DEV"] = True
        conf.env["GX_LIB_STATIC"] = False
    if Options.options.no_ldconfig:
        conf.env["NO_LDCONFIG"] = True


def template2cc(task):
    basename = os.path.splitext(
        os.path.basename(task.inputs[0].srcpath(task.env)))[0]
    srcdir = task.inputs[0].parent
    try:
        os.remove(task.outputs[0].bldpath(task.env))
    except OSError:
        pass
    try:
        os.mkdir(task.outputs[0].parent.bldpath(task.env) + "/private")
    except OSError:
        pass
    spath = srcdir.srcpath(task.env)
    dpath = srcdir.bldpath(task.env)
    cmd = ["%s/gmmproc" % task.env["GMMPROCDIR"],
           "--defs", dpath,
           "-I", spath,
           "-I", "%s" % task.env["GTK_GMMPROCM4DIR"],
           "-I", "%s" % task.env["ATK_GMMPROCM4DIR"],
           "-I", "%s" % task.env["PANGO_GMMPROCM4DIR"],
           basename,
           spath,
           dpath,
           ]
    Logs.debug("runner: system command -> %s" % cmd)
    ret = Utils.exec_command(cmd, shell=False)
    if ret != 0:
        return ret
    dpath += "/"
    spath += "/../gxwmm-generated/"
    try:
        shutil.copy2(dpath+basename+".cc", spath+basename+".cc")
        shutil.copy2(dpath+basename+".h", spath+basename+".h")
        shutil.copy2(dpath+"private/"+basename+"_p.h", spath+"private/"+basename+"_p.h")
    except (OSError, IOError) as e:
        Logs.error("runner: cannot copy file -> %s" % e)
        return e.errno
    return 0

Task.task_type_from_func(
    'gmmproc',
    template2cc,
    color='BLUE',
    before='cxx')

@extension('.hg')
def process_hg(self, node):
        cc_node = node.change_ext('.cc')
        task = self.create_task('gmmproc', [node], [cc_node])
        task.after = ["gxwdefs"]
        task.deps_nodes.append(
            node.parent.find_resource(node.name.replace('.hg','.ccg')))
        task.deps_nodes.append(
            node.parent.find_or_declare('gxw.defs'))
        self.allnodes.append(cc_node)

def header2defs(task):
    sources = " ".join(["'%s'" % v.srcpath(task.env) for v in task.inputs[1:]])
    path = task.generator.path
    dst = task.outputs[0].bldpath(task.env)
    flt = task.inputs[0].srcpath(task.env)
    cmd = ("python '%s'/h2def.py -f '%s' -m gxw %s > '%s'"
           % (task.env["CODEGENDIR"], flt, sources, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd, shell=True)

def build_generate_wrapper(bld):
    header = ["GxTuner.h",
              "GxRackTuner.h",
              "GxFastMeter.h",
              "GxWaveView.h",
              "GxRegler.h",
              "GxSelector.h",
              "GxSwitch.h",
              "GxToggleImage.h",
              "GxControlParameter.h",
              "GxIREdit.h",
              "GxRadioButton.h",
              "GxWheel.h",
              "GxWheelVertical.h",
              "GxKnob.h",
              "GxBigKnob.h",
              "GxMidKnob.h",
              "GxSmallKnob.h",
              "GxSmallKnobR.h",
              "GxHSlider.h",
              "GxMiniSlider.h",
              "GxVSlider.h",
              "GxEQSlider.h",
              "GxLevelSlider.h",
              "GxPaintBox.h",
              "GxMeterScale.h",
              "GxGradient.h",
              "GxValueDisplay.h",
              "GxSimpleValueDisplay.h",
              "GxPortDisplay.h",
              "GxPlayHead.h",
              ]
    header = ["../../libgxw/gxw/"+v for v in header]
    bld(features = ['cxx', 'cprogram'],
        source = "generate_defs_gxw.cc",
        includes = ["../../libgxw"],
        uselib = ['GTKMM'],
        lib    = 'glibmm_generate_extra_defs-2.4',
        uselib_local = "gxw",
        target = 'generate_defs_gxw',
        install_path = None,
        )
    bld.add_group()
    libdir = bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env)
    e1 = 's/GdkEvent\\*/GdkEventButton*/'
    e2 = 's/return-type "const-gchar\\*"/return-type "gchar*"/'
    bld(name = "sigdefs",
        rule = ("LD_LIBRARY_PATH=\"%s\" ${SRC} | sed -e '"+e1+"' -e '"+e2+"'> ${TGT}") % libdir, #FIXME
        source = 'generate_defs_gxw',
        target = 'signals.defs',
        )
    bld(name = "mthdefs",
        rule = header2defs,
        source = ['filter.defs']+header,
        target = "methods.defs",
        )
    bld(name = "enumdefs",
        rule = bld.path.srcpath(bld.env)+"/enum.pl ${SRC} > ${TGT}",
        source = header,
        target = "enum.defs",
        )
    bld(name = "gxwdefs",
        rule = 'for f in ${SRC}; do echo "(include $(basename $f))"; done > ${TGT}',
        source = ["methods.defs","signals.defs","enum.defs"],
        target = "gxw.defs",
        after = ["sigdefs","mthdefs","enumdefs"],
        )
    bld(rule = "cp ${SRC} ${TGT}",
        source = "docs.xml",
        target = "gxw_docs.xml",
        )

def build(bld):
    sources = [
        "controlparameter.hg",
        "switch.hg",
        "regler.hg",
        "knob.hg",
        "bigknob.hg",
        "midknob.hg",
        "smallknob.hg",
        "smallknobr.hg",
        "tuner.hg",
        "racktuner.hg",
        "fastmeter.hg",
        "waveview.hg",
        "selector.hg",
        "toggleimage.hg",
        "iredit.hg",
        "radiobutton.hg",
        "wheel.hg",
        "wheelvertical.hg",
        "hslider.hg",
        "minislider.hg",
        "vslider.hg",
        "eqslider.hg",
        "levelslider.hg",
        "paintbox.hg",
        "meterscale.hg",
        #"gradient.hg",
        "valuedisplay.hg",
        "simplevaluedisplay.hg",
        "portdisplay.hg",
        "playhead.hg",
        ]
    if bld.env["USE_GENERATED_CPP"]:
        gdir = "../gxwmm-generated/"
        for v in sources:
            s = v.replace(".hg", ".cc")
            bld(name = "copy-generated-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
            s = v.replace(".hg", ".h")
            bld(name = "copy-generated-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
            s = v.replace(".hg", "_p.h")
            bld(name = "copy-generated-p-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + "private/" + s,
                target = "private/" + s,
                )
        bld(name = "copy-wrap_init",
            rule = "cp ${SRC} ${TGT}",
            source = gdir + "wrap_init.cc",
            target = 'wrap_init.cc',
            )
        sources = [v.replace(".hg",".cc") for v in sources]
    else:
        bld(name = "wrap_init",
            rule = bld.env["GMMPROCDIR"]+"/generate_wrap_init.pl --namespace=Gxw ${SRC} >${TGT}; cp ${TGT} ../libgxwmm/gxwmm-generated", #FIXME
            source = sources,
            target = "wrap_init.cc",
            )
        build_generate_wrapper(bld)
    bld.add_group()
    if bld.env["GX_LIB_SHARED"]:
        bld(features = ['cxx', 'cshlib', 'libtool'],
            type = 'cshlib',
            vnum = "0.1",
            includes = ['..','../../libgxw'],
            source = sources+["init.cc","wrap_init.cc"],
            uselib = ['GTKMM'],
            uselib_local = ['gxw'],
            target = 'gxwmm',
            )
    else:
        bld(features = ['cxx', 'cstaticlib'],
            includes = ['..','../../libgxw'],
            #cxxflags = ['-fPIC'],
            source = sources+["init.cc","wrap_init.cc"],
            uselib = ['GTKMM'],
            target = 'gxwmm',
            )

=== src/LV2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import os, re

def sub_file(src_fname, dst_fname, lst):

    f = open(src_fname, 'rU')
    txt = f.read()
    f.close()

    for (key, val) in lst:
        re_pat = re.compile(key, re.M)
        txt = re_pat.sub(val, txt)

    f = open(dst_fname, 'w')
    f.write(txt)
    f.close()

def append_sse_flags():
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        return False
    model = cpu_model.split()
    arch = os.uname()[4]

    if "sse2" in x86_flags:
        return True
    else:
        return False

def dirlist():
    subdirs = [
        'gx_amp.lv2',
        'gx_amp_stereo.lv2',
        'gxautowah.lv2',
        'gxbooster.lv2',
        'gx_chorus.lv2',
        'gx_compressor.lv2',
        'gx_delay.lv2',
        'gxechocat.lv2',
        'gx_echo.lv2',
        'gx_expander.lv2',
        'gx_flanger.lv2',
        'gxmetal_amp.lv2',
        'gxmetal_head.lv2',
        'gx_phaser.lv2',
        #'gxpreamp.lv2',
        #'gxpreamp.lv2/StereoAmp',
        'gx_redeye.lv2',
        'gx_reverb.lv2',
        'gx_studiopre.lv2',
        'gx_studiopre_st.lv2',
        'gxtilttone.lv2',
        'gx_tremolo.lv2',
        'gxts9.lv2',
        'gxtubedelay.lv2',
        'gxtubetremelo.lv2',
        'gxtubevibrato.lv2',
        'gxtuner.lv2',
        'gx_zita_rev1.lv2',
        'gx_mbdistortion.lv2',
        'gx_mbdelay.lv2',
        'gx_mbecho.lv2',
        'gx_mbcompressor.lv2',
        'gx_fuzz.lv2',
        'gx_graphiceq.lv2',
        'gx_duck_delay.lv2',
        'gx_duck_delay_st.lv2',
        'gx_barkgraphiceq.lv2',
        'gx_detune.lv2',
        'gx_shimmizita.lv2',
        'gx_switched_tremolo.lv2',
        'gx_room_simulator.lv2',
        'gx_digital_delay.lv2',
        'gx_digital_delay_st.lv2',
        'gx_livelooper.lv2',
        'gx_mbreverb.lv2',
        'gx_jcm800pre.lv2',
        'gx_jcm800pre_st.lv2',
        'gx_cabinet.lv2',
        'gx_vibe.lv2',
        'gx_fuzzface.lv2',
        'gx_fuzzfacefm.lv2',
        'gx_hfb.lv2',
        'gx_hornet.lv2',
        'gx_muff.lv2',
        'gx_scream.lv2',
        'gx_susta.lv2',
        'gx_cstb.lv2',
        'gx_fumaster.lv2',
        'gx_oc_2.lv2',
        'gx_mole.lv2',
        'gx_rangem.lv2',
        'gx_hogsfoot.lv2',
        'gx_wah.lv2',
        'gx_gcb_95.lv2',
        'gx_aclipper.lv2',
        'gx_bmp.lv2',
        'gx_bossds1.lv2',
        'gx_mxrdist.lv2',
        'gxtape.lv2',
        'gxtape_st.lv2',
        'gx_alembic.lv2',
        'gx_w20.lv2',


       ]

    return subdirs

def configure(conf):
    if not conf.env['NOSSE']:
        conf.env['SSE2'] = append_sse_flags()
    pa = '.so'

    for x in dirlist():
        conf.sub_config('%s' % x);
        if conf.env['MODGUI']:
            sub_file('./src/LV2/%s/manifest.ttl.in' % x, './src/LV2/%s/manifest.ttl' % x, (('@LIB_EXT@', '%s' % pa), ))
        else:
            sub_file('./src/LV2/%s/manifest.ttl.in' % x, './src/LV2/%s/manifest.ttl' % x, (('@LIB_EXT@', '%s' % pa), (',\n        <modgui.ttl> ','%s' % ' '), (', <modgui.ttl>','%s' % ' '), (', <modguis.ttl>','%s' % ' ')))

def build(bld):
    # faust folder keep out of dirlist
    bld.add_subdirs('faust')
    bld.add_subdirs(dirlist())

    if bld.env['LV2GUI']:
        gx_ampstyledir = bld.path.find_dir( 'GUI' ) ;
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.png'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.rc'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)

=== src/faust/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import wscript_helper

def build(bld):
    unused_sources = [
        'preamp.dsp',
        'inputgain.dsp',
        'AntiAlias.dsp',
        'HighShelf.dsp',
        'drive.dsp',
        'osc_tube.dsp',
        'reso_tube.dsp',
        'tube.dsp',
        'tube3.dsp',
        'tubevibrato.dsp',
        'multifilter.dsp',
        'eq.dsp',
        'outputgain.dsp',
        'feed.dsp',
        'balance1.dsp',
        'amp2.dsp',
        'stage3.dsp',
        'distortion.dsp',
        'distortion1.dsp',
        'noisegate.dsp',
        'sloop.dsp', ##float
        'vibe_lfo_triangle.dsp',
        'vibe_mono_lfo_triangle.dsp',
        ]

    sources_float = [
        'jconv_post.dsp',
        ]

    sources = [
        'jconv_post_mono.dsp',
        'presence_level.dsp',
        'cabinet_impulse_former.dsp',
        'cabinet_impulse_former_st.dsp',
        'preamp_impulse_former.dsp',
        'preamp_impulse_former_st.dsp',
        'drumseq.dsp',
        ]

    sources_static = [
        'vibe_mono_lfo_sine.dsp',
        'vibe_lfo_sine.dsp',
        ]

    sources_plugin_float = [
        'echo.dsp',
        'delay.dsp',
        'chorus.dsp',
        'chorus_mono.dsp',
        'stereodelay.dsp',
        'stereoecho.dsp',
        'digital_delay.dsp',
        'digital_delay_st.dsp',
        'phaser.dsp',
        'phaser_mono.dsp',
        'crybaby.dsp',
        'autowah.dsp',
        ]

    sources_plugin_double = [
        'selecteq.dsp',

        # tone stacks
        'tonestack_default.dsp',  # this one also ok in single precision
        'tonestack_bassman.dsp',
        'tonestack_twin.dsp',
        'tonestack_princeton.dsp',
        'tonestack_jcm800.dsp',
        'tonestack_jcm2000.dsp',
        'tonestack_mlead.dsp',
        'tonestack_m2199.dsp',
        'tonestack_ac30.dsp',
        'tonestack_soldano.dsp',
        'tonestack_mesa.dsp',
        'tonestack_jtm45.dsp',
        'tonestack_ac15.dsp',
        'tonestack_peavey.dsp',
        'tonestack_ibanez.dsp',
        'tonestack_roland.dsp',
        'tonestack_ampeg.dsp',
        'tonestack_ampeg_rev.dsp',
        'tonestack_sovtek.dsp',
        'tonestack_bogner.dsp',
        'tonestack_groove.dsp',
        'tonestack_crunch.dsp',
        'tonestack_fender_blues.dsp',
        'tonestack_fender_default.dsp',
        'tonestack_fender_deville.dsp',
        'tonestack_gibsen.dsp',
        'tonestack_engl.dsp',
        ]

    sources_plugin = [
        'low_high_pass.dsp',
        'gx_distortion.dsp',
        'bitdowner.dsp',
        'thick_distortion.dsp',
        'impulseresponse.dsp',
        'compressor.dsp',
        'expander.dsp',
        'overdrive.dsp',
        'freeverb.dsp',
        'biquad.dsp',
        'tremolo.dsp',
        'flanger_mono.dsp',
        'gx_feedback.dsp',
        'flanger.dsp',
        'moog.dsp',
        'gx_ampmodul.dsp',
        'tonecontroll.dsp',
        'stereoverb.dsp',
        'softclip.dsp',
        'gx_ampout.dsp',
        'gx_ampout_ladspa.dsp',
        'noise_shaper.dsp',
        'bassbooster.dsp',
        'gx_outputlevel.dsp',
        'gx_outputlevel_ladspa.dsp',
        'gxfeed.dsp',
        'highbooster.dsp',
        'peak_eq.dsp',
        'dattorros_progenitor.dsp',
        'ring_modulator.dsp',
        'ring_modulator_st.dsp',
        'panoram_enhancer.dsp',
        'graphiceq.dsp',
        'bass_enhancer.dsp',
        'gain.dsp',
        'duck_delay.dsp',
        'duck_delay_st.dsp',
        'baxandall.dsp',
        'distortion2.dsp',
        'fuzzface.dsp',
        'trbuff.dsp',
        'colwah.dsp',
        'dallaswah.dsp',
        'foxwah.dsp',
        'maestrowah.dsp',
        'voxwah.dsp',
        'selwah.dsp',
        'jenwah.dsp',
        'colbwah.dsp',
        'rolwah.dsp',
        'jenbasswah.dsp',


        # amps
        'gxamp.dsp',
        'gxamp2.dsp',
        'gxamp3.dsp',
        'gxamp4.dsp',
        'gxamp5.dsp',
        'gxamp6.dsp',
        'gxamp7.dsp',
        'gxamp8.dsp',
        'gxamp9.dsp',
        'gxamp10.dsp',
        'gxamp11.dsp',
        'gxamp12.dsp',
        'gxamp13.dsp',
        'gxamp14.dsp',
        'gxamp15.dsp',
        'gxamp16.dsp',
        'gxamp17.dsp',
        'gxamp18.dsp',
        'gxnoamp.dsp',

        # bypass mode
        'balance.dsp',
        ]

    if bld.env['FAUST']:
        arg, float_arg, double_arg = wscript_helper.get_faust_args(bld)
        bld.new_task_gen(
            source = sources,
            proc = "../tools/dsp2cc",
            separate_header = True,
            proc_args = arg+["--init-type=no-init-instance"],
            )
        bld.new_task_gen(
            source = sources_float,
            proc = "../tools/dsp2cc",
            separate_header = True,
            proc_args = float_arg+["--init-type=no-init-instance"],
            )
        bld.new_task_gen(
            source = sources_static,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=no-init"],
            )
        bld.new_task_gen(
            source = sources_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-instance"],
            )
        bld.new_task_gen(
            source = sources_plugin_float,
            proc = "../tools/dsp2cc",
            proc_args = float_arg+["--init-type=plugin-instance"]
            )
        bld.new_task_gen(
            source = sources_plugin_double,
            proc = "../tools/dsp2cc",
            proc_args = double_arg+["--init-type=plugin-instance"]
            )
    else:
        gdir = "../faust-generated/"
        for s in (sources + sources_static + sources_float +
                  sources_plugin_float + sources_plugin_double + sources_plugin):
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
        for s in sources + sources_float:
            s = s.replace(".dsp",".h")
            bld(name = "copy-faust-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
    bld.add_group()

def configure(conf):
    pass

=== src/gx_head/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, wscript_helper
import Task, Utils, Options, Logs, os, shutil
from TaskGen import extension

def set_options(opt):
    guitarix_prog = opt.add_option_group("Guitarix Program Options")
    guitarix_prog.add_option(
        '--no-avahi', action='store_const', default=False, const=True,
        help=('Do not build with avahi support for automatic discovery of'
              ' / connection to Guitarix server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--no-bluez', action='store_const', default=False, const=True,
        help=('Do not build with bluez support for remote'
              ' / connection to Guitarix server instances  [Default: no]'))

def configure(conf):
    if not Options.options.no_avahi:
        conf.check_cfg(package='avahi-gobject', args='--cflags --libs', uselib_store='AVAHI_GOBJECT', mandatory=1)
        conf.check_cfg(package='avahi-glib', args='--cflags --libs', uselib_store='AVAHI_GLIB', mandatory=1)
        conf.check_cfg(package='avahi-client', args='--cflags --libs', uselib_store='AVAHI_CLIENT', mandatory=1)
        conf.define("HAVE_AVAHI", 1)
    if not Options.options.no_bluez:
        conf.check_cfg(package='bluez', args='--cflags --libs', uselib_store='BLUEZ', mandatory=0)

def gperf2cc(task):
    out_c = task.outputs[0].bldpath(task.env)
    out_h = task.outputs[1].bldpath(task.env)
    basename = os.path.splitext(
        os.path.basename(task.inputs[0].srcpath(task.env)))[0]
    srcdir = task.inputs[0].parent.srcpath(task.env)
    if task.env["HAVE_GPERF"]:
        cmd = [task.proc,
               task.inputs[0].srcpath(task.env),
               out_c,
               out_h,
               ]
        Logs.debug("runner: system command -> %s" % cmd)
        ret = Utils.exec_command(cmd, shell=False)
        shutil.copy2(out_c, os.path.join(srcdir, basename+"-generated.cc"))
        shutil.copy2(out_h, os.path.join(srcdir, basename+"-generated.h"))
        return ret
    else:
        shutil.copy2(os.path.join(srcdir, basename+"-generated.cc"), out_c)
        shutil.copy2(os.path.join(srcdir, basename+"-generated.h"), out_h)
        return 0

Task.task_type_from_func(
    'gperf',
    gperf2cc,
    color='BLUE',
    before='cc cxx',
    )

@extension('.gperf_tmpl')
def process_gperf_tmpl(self, node):
    cc_node = node.change_ext('.cc')
    h_node = node.change_ext('.h')
    task = self.create_task('gperf', [node], [cc_node, h_node])
    task.proc = "../tools/make_jsonrpc_methods"
    self.bld.add_manual_dependency(node,self.bld.bldnode.find_resource(task.proc))

def build(bld):
    sources_engine = [
        './engine/gx_logging.cpp',
        './engine/gx_pluginloader.cpp',
        './engine/ladspaplugin.cpp',
        './engine/ladspaback.cpp',
        './engine/tunerswitcher.cpp',
        './engine/jsonrpc.cpp',
        './engine/gx_jack.cpp',
        './engine/gx_preset.cpp',
        './engine/gx_json.cpp',
        './engine/gx_faust_plugins.cpp',
        './engine/gx_internal_plugins.cpp',
        './engine/gx_internal_ui_plugins.cpp',
        './engine/gx_midi_plugin.cpp',
        './engine/gx_engine_audio.cpp',
        './engine/gx_paramtable.cpp',
        './engine/gx_pitch_tracker.cpp',
        './engine/gx_convolver.cpp',
        './engine/gx_resampler.cpp',
        './engine/gx_system.cpp',
        './engine/gx_engine.cpp',
        './engine/gx_engine_midi.cpp',
        './engine/jsonrpc_methods.gperf_tmpl',
        ]

    sources_gui = [
        './gui/machine.cpp',
        './gui/ladspalist.cpp',
        './gui/gx_stackbox_builder.cpp',
        './gui/gx_main_window.cpp',
        './gui/liveplay.cpp',
        './gui/rack.cpp',
        './gui/gx_preset_window.cpp',
        './gui/gx_jack_options.cpp',
        './gui/gx_ui_builder.cpp',
        './gui/gx_gui_helpers.cpp',
        './gui/gx_child_process.cpp',
        './gui/gx_main_midi.cpp',
        './gui/gx_jconv_settings.cpp',
        './gui/gx_sequencer_settings.cpp',
        './gui/gxw_mm_controllers.cpp',
        './gui/gx_main_boxes.cpp',
        './gui/gx_mono_rack_builder.cpp',
        './gui/gx_stereo_rack_builder.cpp',
        './gui/gx_cairo_callbacks.cpp',
        './gui/gx_portmap.cpp',
        './gui/gx_main.cpp',
        ]

    builder_files = [
        './builder/midi.glade',
        './builder/midi_channel.glade',
        './builder/ports.glade',
        './builder/iredit.glade',
        './builder/iredit_mono.glade',
        './builder/jackstarter.glade',
        './builder/mainpanel.glade',
        './builder/ladspaliste.glade',
        './builder/crybaby_ui.glade',
        './builder/wah_ui.glade',
        './builder/vibe_ui.glade',
        './builder/vibe_stereo_ui.glade',
        './builder/reversedelay_ui.glade',
        './builder/gx_distortion_ui.glade',
        './builder/gx_record_ui.glade',
        './builder/gx_st_record_ui.glade',
        './builder/gx_detune_ui.glade',
        './builder/amp.tonestack_ui.glade',
        './builder/ampimpulse_ui.glade',
        './builder/ampimpulse_st_ui.glade',
        './builder/cabinet_ui.glade',
        './builder/cabinet_stereo_ui.glade',
        './builder/tremolo_ui.glade',
        './builder/pluginpreset_inputwindow.glade',
        './builder/pluginpreset_listwindow.glade',
        './builder/pluginpreset_connectwindow.glade',
        './builder/selectinstance.glade',
        './builder/Sequencer.glade',
        './builder/menudef.xml',
        './builder/accels_rc',
        './builder/gx_plugins.png',
        './builder/gx_rack.png',
        './builder/gx_show.png',
        './builder/gx_split.png',
        './builder/gx_tuner.png',
        './builder/gx_config.png',
        './builder/gx_fold.png',
        './builder/gx_fullscreen.png',
        ]

    if bld.env["HAVE_AVAHI"]:
        sources_gui.append("gui/avahi_discover.cpp")
        sources_engine.append("engine/avahi_register.cpp")
    sources = sources_engine + sources_gui
    incl = ['.','./engine','../..','..','../headers','../../libgxwmm','../../libgxw'] # need ".." for config.h
    libpath = []
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT', 'CURL',
              'GTK2', 'GTKMM', 'GIOMM', 'FFTW3', 'LRDF', 'LILV', 'BOOST_SYSTEM','BOOST_IOSTREAMS']
    if bld.env["HAVE_AVAHI"]:
        uselib += ['AVAHI_GOBJECT', 'AVAHI_GLIB', 'AVAHI_CLIENT']
    if bld.env["HAVE_BLUEZ"]:
        uselib.append('BLUEZ')
    uselib_local = []
    wscript_helper.add_zita_convolver(bld, uselib, sources, incl)
    wscript_helper.add_zita_resampler(bld, uselib, sources, incl)
    if bld.env["HAVE_PLUGINLIB"]:
        uselib_local += ["plugins"]
    if bld.env["GX_LIB_SHARED"]:
        lib += ['gxwmm','gxw']
        libpath += [bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local += ['gxwmm','gxw']
    ldscript = bld.path.find_resource('guitarix.lds')
    mapfile = bld.path.find_or_declare("guitarix.map")
    task = bld(features = 'cxx cprogram',
        includes = incl,
        obj_ext  = '.o',
        source = sources,
        lib = lib,
        uselib = uselib,
        uselib_local = uselib_local,
        libpath = libpath,
        target = bld.env['BIN_NAME'],
        chmod = 0o755,
        install_path = bld.env['BINDIR'],
        ldflags = ['-Wl,%s,-Map,%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(task.target), ldscript)
    bld.install_files(bld.env['GX_BUILDER_DIR'], builder_files, chmod=0o644)

=== src/ladspa/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

@TaskGen.feature('test_loadable')
def test_loadable(self):
    def link_and_test(lib=self.link_task.outputs[0].bldpath(self.env), link=self.link_task.run):
        link()
        try:
            ctypes.cdll.LoadLibrary(lib)
        except Exception as e:
            raise RuntimeError("LADSPA load test failed: %s" % e)
    self.link_task.run = link_and_test

def build(bld):
    bsources = [
        '../gx_head/engine/gx_json.cpp',
        '../gx_head/engine/gx_faust_plugins.cpp',
        '../gx_head/engine/gx_internal_plugins.cpp',
        '../gx_head/engine/gx_engine_audio.cpp',
        '../gx_head/engine/gx_paramtable.cpp',
        '../gx_head/engine/gx_convolver.cpp',
        '../gx_head/engine/gx_resampler.cpp',
        '../gx_head/engine/gx_system.cpp',
        '../gx_head/engine/gx_logging.cpp',
        '../gx_head/engine/gx_pluginloader.cpp',
        ## lib can't be used (-fPIC)
        '../plugins/generated/zita_rev1.cc',
        '../plugins/vibe.cc',
        '../plugins/abgate.cc',
        '../plugins/generated/ts9sim.cc',
        '../plugins/generated/aclipper.cc',
        '../plugins/generated/mxrdist.cc',
        '../plugins/generated/bossds1.cc',
        '../plugins/generated/flanger_gx.cc',
        '../plugins/generated/mbc.cc',
        '../plugins/generated/mbcs.cc',
        '../plugins/generated/mbd.cc',
        '../plugins/generated/mbe.cc',
        '../plugins/generated/mbdel.cc',
        '../plugins/generated/mbchor.cc',
        '../plugins/reversedelay.cc',
        '../plugins/generated/gcb_95.cc',
        '../plugins/generated/hfb.cc',
        '../plugins/generated/hogsfoot.cc',
        '../plugins/generated/lpbboost.cc',
        '../plugins/generated/rolandwah.cc',
        '../plugins/metronome.cc',
    ]

    src = ['ladspa_guitarix.cpp'] + bsources
    incl = ['../headers', '..','../gx_head/engine','../plugins','../../libgxwmm','../../libgxw']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT',
              'GLIBMM', 'GIOMM', 'FFTW3', 'BOOST_SYSTEM', 'LILV']
    wscript_helper.add_zita_convolver(bld, uselib, src, incl)
    wscript_helper.add_zita_resampler(bld, uselib, src, incl)
    ladspa_plugin = bld(
        #features='cxx cprogram',  ## for debugging
        features='cxx cshlib test_loadable',
        includes = incl,
        lib = lib,
        uselib = uselib,
        #uselib_local = ["plugins"], ## needs -fPIC
        cxxflags = ["-fvisibility=hidden"],
        defines = ["LADSPA_SO"],
        target   = 'ladspa_guitarix',
        source   = src,
        install_path = '${LADSPADIR}',
        chmod = 0o755,
        )
    ladspa_plugin.env['shlib_PATTERN'] = '%s.so'
    bld.install_files('${SHAREDIR}/ladspa/rdf', 'guitarix_amp.rdf')

=== src/LV2/gx_aclipper.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_aclipper.lv2'

    src = ['gx_aclipper.cpp',
           '../DSP/gx_resampler.cc',
           ]
    incl = ['../faust','./', '../DSP']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    wscript_helper.add_zita_resampler(bld, uselib, src, incl, base="../..")
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_20.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_aclipper',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'

    if bld.env['LV2GUI']:
        uselib_local1 = []
        libpath1 = []
        lib1 = []
        incl = ['../../../libgxwmm','../../../libgxw']
        if sys.platform.startswith("linux"):
            lib1.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib1 += ['gxwmm','gxw']
            libpath1 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local1 += ['gxwmm','gxw']

        lv2_plugin_gui = bld(
            features='cxx cshlib ',
            includes = incl,
            lib = lib1,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath1,
            uselib_local = uselib_local1,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_aclipper_gui',
            source   = 'widget.cpp gx_aclipper_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_plugin_gui.env['shlib_PATTERN'] = '%s.so'

    install_path = '${LV2DIR}/%s' % bundle,
    if bld.env['MODGUI']:
        bld.install_files('${LV2DIR}/gx_aclipper.lv2', bld.path.ant_glob('*.ttl'), relative_trick=True)
        bld.install_files('${LV2DIR}/gx_aclipper.lv2', bld.path.ant_glob('modgui/**/*'), relative_trick=True)
    else:
        bld.install_files('${LV2DIR}/gx_aclipper.lv2', bld.path.ant_glob('*.ttl', excl=['modgui.ttl']), relative_trick=True)

=== src/LV2/gx_alembic.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_alembic.lv2'

    src = ['gx_alembic.cpp'
           ]
    incl = ['../faust','../faust-generated','./', '../DSP', '../DSP/tube_tables']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_5.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_alembic',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'

    if bld.env['LV2GUI']:
        uselib_local5 = []
        libpath5 = []
        lib5 = []
        incl5 = ['../../../libgxwmm','../../../libgxw','../']
        if sys.platform.startswith("linux"):
            lib5.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib5 += ['gxwmm','gxw']
            libpath5 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local5 += ['gxwmm','gxw']

        lv2_effetcs_gui = bld(
            features='cxx cshlib ',
            includes = incl5,
            lib = lib5,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath5,
            uselib_local = uselib_local5,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_alembic_gui',
            source   = 'widget.cpp gx_alembic_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_effetcs_gui.env['shlib_PATTERN'] = '%s.so'


    install_path = '${LV2DIR}/%s' % bundle,
    if bld.env['MODGUI']:
        bld.install_files('${LV2DIR}/gx_alembic.lv2', bld.path.ant_glob('*.ttl'), relative_trick=True)
        bld.install_files('${LV2DIR}/gx_alembic.lv2', bld.path.ant_glob('modgui/**/*'), relative_trick=True)
    else:
        bld.install_files('${LV2DIR}/gx_alembic.lv2', bld.path.ant_glob('*.ttl', excl=['modgui.ttl']), relative_trick=True)

=== src/LV2/gx_amp.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_amp.lv2'

    src = ['gxamp.cpp',
           'gx_amp.cc',
           'gx_tonestack.cc',
           '../DSP/gx_resampler.cc',
           '../DSP/gx_convolver.cc'
           ]
    incl = ['../faust','./', '../DSP', '../DSP/tube_tables']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE','GLIBMM']
    if not bld.env['ZITA_CONVOLVER']:
        if not bld.env['CONVOLVER_FFMPEG']:
            uselib.append('FFTW3')
    wscript_helper.add_zita_convolver(bld, uselib, src, incl, base="../..")
    wscript_helper.add_zita_resampler(bld, uselib, src, incl, base="../..")
    cxxflag =[]
    ldscript = bld.path.find_resource('gx_amp.lds')
    mapfile = bld.path.find_or_declare("gx_amp.map")
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_plugin = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_8.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_amp',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(lv2_plugin.target), ldscript)
    lv2_plugin.env['shlib_PATTERN'] = '%s.so'

    if bld.env['LV2GUI']:
        uselib_local1 = []
        libpath1 = []
        lib1 = []
        incl = ['../../../libgxwmm','../../../libgxw']
        if sys.platform.startswith("linux"):
            lib1.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib1 += ['gxwmm','gxw']
            libpath1 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local1 += ['gxwmm','gxw']

        lv2_plugin_gui = bld(
            features='cxx cshlib ',
            includes = incl,
            lib = lib1,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath1,
            uselib_local = uselib_local1,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_amp_gui',
            source   = 'widget.cpp gxamp_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_plugin_gui.env['shlib_PATTERN'] = '%s.so'


    install_path = '${LV2DIR}/%s' % bundle,
    if bld.env['MODGUI']:
        bld.install_files('${LV2DIR}/gx_amp.lv2', bld.path.ant_glob('*.ttl'), relative_trick=True)
        bld.install_files('${LV2DIR}/gx_amp.lv2', bld.path.ant_glob('modgui/**/*'), relative_trick=True)
    else:
        bld.install_files('${LV2DIR}/gx_amp.lv2', bld.path.ant_glob('*.ttl', excl=['modgui.ttl']), relative_trick=True)

=== src/LV2/gx_amp_stereo.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes, wscript_helper

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_amp_stereo.lv2'

    src = ['gxamp_stereo.cpp',
           'gx_amp_stereo.cc',
           'gx_tonestack_stereo.cc',
           '../DSP/gx_resampler.cc',
           '../DSP/gx_convolver.cc'
           ]
    incl = ['../faust','./', '../DSP', '../DSP/tube_tables']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE','GLIBMM']
    if not bld.env['ZITA_CONVOLVER']:
        if not bld.env['CONVOLVER_FFMPEG']:
            uselib.append('FFTW3')
    wscript_helper.add_zita_convolver(bld, uselib, src, incl, base="../..")
    wscript_helper.add_zita_resampler(bld, uselib, src, incl, base="../..")
    cxxflag =[]
    ldscript = bld.path.find_resource('gxamp_stereo.lds')
    mapfile = bld.path.find_or_declare("gxamp_stereo.map")
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_plugin = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_13.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_amp_stereo',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        ldflags = ['-Wl,%s,-Map=%s' % (ldscript.srcpath(),mapfile.bldpath(bld.env))],
        )
    bld.add_manual_dependency(bld.path.find_or_declare(lv2_plugin.target), ldscript)
    lv2_plugin.env['shlib_PATTERN'] = '%s.so'

    if bld.env['LV2GUI']:
        uselib_local1 = []
        libpath1 = []
        lib1 = []
        incl = ['../../../libgxwmm','../../../libgxw']
        if sys.platform.startswith("linux"):
            lib1.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib1 += ['gxwmm','gxw']
            libpath1 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local1 += ['gxwmm','gxw']

        lv2_plugin_gui = bld(
            features='cxx cshlib ',
            includes = incl,
            lib = lib1,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath1,
            uselib_local = uselib_local1,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_amp_stereo_gui',
            source   = 'widget_stereo.cpp gxamp_stereo_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_plugin_gui.env['shlib_PATTERN'] = '%s.so'


    install_path = '${LV2DIR}/%s' % bundle,
    if bld.env['MODGUI']:
        bld.install_files('${LV2DIR}/gx_amp_stereo.lv2', bld.path.ant_glob('*.ttl'), relative_trick=True)
        bld.install_files('${LV2DIR}/gx_amp_stereo.lv2', bld.path.ant_glob('modgui/**/*'), relative_trick=True)
    else:
        bld.install_files('${LV2DIR}/gx_amp_stereo.lv2', bld.path.ant_glob('*.ttl', excl=['modgui.ttl']), relative_trick=True)

=== src/LV2/gx_barkgraphiceq.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import sys, os, TaskGen, ctypes

def configure(conf):
    pass

def build(bld):
    bundle = 'gx_barkgraphiceq.lv2'

    src = ['gx_barkgraphiceq.cpp'
           ]
    incl = ['../faust', './', '../DSP','../../headers']
    lib = []
    if sys.platform.startswith("linux"):
        lib.append('dl')
    uselib = ['LV2CORE']
    cxxflag =[]
    if not bld.env['OPT'] and bld.env['SSE2']:
        cxxflag = [ "-msse2", "-mfpmath=sse"]
    lv2_effects = bld(
        features='cxx cshlib ',
        includes = incl,
        lib = lib,
        uselib = uselib,
        obj_ext  = '_14.o',
        cxxflags = cxxflag,
        defines  = ["LV2_SO"],
        target   = 'gx_barkgraphiceq',
        source   = src,
        install_path = '${LV2DIR}/%s' % bundle,
        chmod = 0o755,
        )
    lv2_effects.env['shlib_PATTERN'] = '%s.so'

    if bld.env['LV2GUI']:
        uselib_local5 = []
        libpath5 = []
        lib5 = []
        incl5 = ['../../../libgxwmm','../../../libgxw','../']
        if sys.platform.startswith("linux"):
            lib5.append('dl')
        if bld.env["GX_LIB_SHARED"]:
            lib5 += ['gxwmm','gxw']
            libpath5 += [bld.path.find_dir("../../../libgxw/gxw").bldpath(bld.env),
                        bld.path.find_dir("../../../libgxwmm/gxwmm").bldpath(bld.env)]
        else:
            uselib_local5 += ['gxwmm','gxw']

        lv2_effetcs_gui = bld(
            features='cxx cshlib ',
            includes = incl5,
            lib = lib5,
            uselib = 'LV2CORE GTKMM',
            libpath = libpath5,
            uselib_local = uselib_local5,
            linkflags = '-Wl,-z,nodelete',
            defines  = ["LV2_GUI"],
            target   = 'gx_barkgraphiceq_gui',
            source   = 'widget.cpp gx_barkgraphiceq_gui.cpp',
            install_path = '${LV2DIR}/%s' % bundle,
            chmod = 0o755,
            )
        lv2_effetcs_gui.env['shlib_PATTERN'] = '%s.so'


    install_path = '${LV2DIR}/%s' % bundle,
    if bld.env['MODGUI']:
        bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2', bld.path.ant_glob('*.ttl'), relative_trick=True)
        bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2', bld.path.ant_glob('modgui/**/*'), relative_trick=True)
    else:
        bld.install_files('${LV2DIR}/gx_barkgraphiceq.lv2', bld.path.ant_glob('*.ttl', excl=['modgui.ttl']), relative_trick=True)

=== debian/changelog ===
guitarix (0.38.1-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Víctor Cuadrado Juan ]
  * Move to dh_missing --fail-missing as dh_install option is deprecated
  * Add version dependency information to shlibs files (Closes: #895151)
  * Remove --no-mod-lv2 from configure as not needed anymore
  * Add --ladspa to configure as it's needed now
  * Remove 02-libdl.patch as not needed anymore
  * Add new Build-Depends on libboost-iostreams-dev
  * Bump dh compat to 11, no changes needed
  * Bump Std-Ver to 4.1.5, Added Rules-Requires-Root: no
  * Update d/watch to version 4
  * New upstream version 0.38.1
  * Fix guitarix-doc files location
  * Remove trailing whitespace in d/rules

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat
  * d/watch: Use https protocol

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump debhelper compat to 12.
    - Bump Standards-Version.
  * debian/gxw-glade.lintian-overrides: Override incorrect lintian error.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 09 Sep 2019 21:00:58 +0200

=== debian/control ===
Source: guitarix
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Víctor Cuadrado Juan <me@viccuad.me>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               intltool,
               ladspa-sdk,
               libavahi-gobject-dev,
               libbluetooth-dev [linux-any],
               libboost-dev (>= 1.53),
               libboost-system-dev (>= 1.53),
               libboost-thread-dev (>= 1.53),
               libboost-iostreams-dev,
               libeigen3-dev,
               libgtk2.0-dev,
               libgtkmm-2.4-dev,
               libjack-dev,
               liblilv-dev,
               liblrdf0-dev,
               libsndfile1-dev,
               libzita-convolver-dev,
               libzita-resampler-dev,
               lv2-dev,
               python,
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.4.0
Homepage: https://guitarix.org
Vcs-Git: https://salsa.debian.org/multimedia-team/guitarix.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/guitarix

Package: guitarix
Architecture: any
Depends: fonts-roboto,
         gtk2-engines,
         gtk2-engines-pixbuf,
         guitarix-common (= ${source:Version}),
         guitarix-ladspa (>= ${source:Version}),
         guitarix-lv2 (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: jack-capture, lame, vorbis-tools, gvfs-backends
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It provides one JACK input port and two JACK output
 ports. It is designed to produce nice trash/metal/rock/blues guitar sounds.
 Controls for bass, treble, gain, compressor, tube selector, distortion,
 flanger, freeverb, crybaby (wah), etc are available.
 .
 Guitarix comes with a GTK+ interface and as Ladspa and LV2 plugins.

Package: guitarix-common
Architecture: all
Multi-Arch: foreign
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}
Description: Guitarix - Common files
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's Architecture independent files. Examples of
 such shared files are: configuration files, images and sounds.

Package: guitarix-ladspa
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Provides: ladspa-plugin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - ladspa plugins
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains the ladspa audio plugins that come together with
 guitarix, but can also be used by any other ladspa host.

Package: guitarix-lv2
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Provides: lv2-plugin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - LV2 plugins
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains the LV2 audio plugins that come together with guitarix,
 but can also be used by any other LV2 host.

Package: guitarix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Suggests: guitarix
Description: Guitarix - Development documentation
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's Development documentation.

Package: libgxw0
Section: libs
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ library
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ library.

Package: libgxw-dev
Section: libdevel
Architecture: any
Depends: libgxw0 (= ${binary:Version}), ${misc:Depends}
Recommends: guitarix-doc
Description: Guitarix - GTK+ library (development files)
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains development files for Guitarix's GTK+ library.

Package: libgxwmm0
Section: libs
Architecture: any
Breaks: guitarix (<< 0.35)
Replaces: guitarix (<< 0.35)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ C++ widget library
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ C++ widget library.

Package: libgxwmm-dev
Section: libdevel
Architecture: any
Depends: libgxwmm0 (= ${binary:Version}), ${misc:Depends}
Recommends: guitarix-doc
Description: Guitarix - GTK+ C++ widget library (development files)
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains development files for Guitarix's GTK+ C++ widget library.

Package: gxw-glade
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Guitarix - GTK+ library Glade support
 Guitarix is a rock guitar amplifier for the Jack Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 trash/metal/rock/blues guitar sounds and comes with a GTK+ interface and as
 Ladspa and LV2 plugins.
 .
 This package contains Guitarix's GTK+ library Glade support.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NUMJOBS = 1
endif

%:
	dh $@

override_dh_auto_configure:
	./waf configure --prefix=/usr --no-faust \
		--cxxflags="$(shell dpkg-buildflags --get CXXFLAGS) \
			$(shell dpkg-buildflags --get CPPFLAGS)" \
		--ldflags="$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed" -v \
		--shared-lib --lib-dev --glade-support --enable-lfs --ladspa

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_build-arch:
	./waf build -v --jobs=$(NUMJOBS)

override_dh_auto_build-indep:
	cd $(CURDIR)/documentation ; doxygen
	# don't use dh_doxygen because it doesn't detect the docs
	cd $(CURDIR)/documentation/html && find . -name "*.md5" -delete
	cd $(CURDIR)/documentation/html && find . -name "*.map" -delete

override_dh_auto_clean:
	./waf distclean
	rm -rf build/*
	rm -rf build/.conf*
	rm -rf build/.waf*
	find . -name "*.pyc" -delete
	rm -rf documentation/html

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/tmp --libdir=$(CURDIR)/debian/tmp
	rm -f $(CURDIR)/debian/tmp/usr/share/gx_head/sounds/bands/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/share/gx_head/sounds/amps/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/lib/libgxwmm.so
	rm -f $(CURDIR)/debian/tmp/usr/lib/libgxw.so
	ln -s libgxwmm.so.0.1 $(CURDIR)/debian/tmp/usr/lib/libgxwmm.so
	ln -s libgxw.so.0.1 $(CURDIR)/debian/tmp/usr/lib/libgxw.so

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
https://sf.net/guitarix/ \
(?:|.*/)guitarix2(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
